// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/blink/renderer/bindings/templates/dictionary_v8.cpp.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "third_party/blink/renderer/bindings/core/v8/v8_reporting_observer_options.h"

#include "base/stl_util.h"
#include "third_party/blink/renderer/bindings/core/v8/idl_types.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"

namespace blink {

static const v8::Eternal<v8::Name>* eternalV8ReportingObserverOptionsKeys(v8::Isolate* isolate) {
  static const char* const kKeys[] = {
    "buffered",
    "types",
  };
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(
      kKeys, kKeys, base::size(kKeys));
}

void V8ReportingObserverOptions::ToImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, ReportingObserverOptions& impl, ExceptionState& exceptionState) {
  if (IsUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.ThrowTypeError("cannot convert to dictionary.");
    return;
  }
  v8::Local<v8::Object> v8Object = v8Value.As<v8::Object>();
  ALLOW_UNUSED_LOCAL(v8Object);

  const v8::Eternal<v8::Name>* keys = eternalV8ReportingObserverOptionsKeys(isolate);
  v8::TryCatch block(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> bufferedValue;
  if (!v8Object->Get(context, keys[0].Get(isolate)).ToLocal(&bufferedValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (bufferedValue.IsEmpty() || bufferedValue->IsUndefined()) {
    // Do nothing.
  } else {
    bool bufferedCppValue = NativeValueTraits<IDLBoolean>::NativeValue(isolate, bufferedValue, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setBuffered(bufferedCppValue);
  }

  v8::Local<v8::Value> typesValue;
  if (!v8Object->Get(context, keys[1].Get(isolate)).ToLocal(&typesValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (typesValue.IsEmpty() || typesValue->IsUndefined()) {
    // Do nothing.
  } else if (typesValue->IsNull()) {
    impl.setTypesToNull();
  } else {
    Vector<String> typesCppValue = NativeValueTraits<IDLSequence<IDLString>>::NativeValue(isolate, typesValue, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setTypes(typesCppValue);
  }
}

v8::Local<v8::Value> ReportingObserverOptions::ToV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8ReportingObserverOptions(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8ReportingObserverOptions(const ReportingObserverOptions& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  const v8::Eternal<v8::Name>* keys = eternalV8ReportingObserverOptionsKeys(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> bufferedValue;
  bool bufferedHasValueOrDefault = false;
  if (impl.hasBuffered()) {
    bufferedValue = v8::Boolean::New(isolate, impl.buffered());
    bufferedHasValueOrDefault = true;
  } else {
    bufferedValue = v8::Boolean::New(isolate, false);
    bufferedHasValueOrDefault = true;
  }
  if (bufferedHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[0].Get(isolate), bufferedValue))) {
    return false;
  }

  v8::Local<v8::Value> typesValue;
  bool typesHasValueOrDefault = false;
  if (impl.hasTypes()) {
    typesValue = ToV8(impl.types(), creationContext, isolate);
    typesHasValueOrDefault = true;
  } else {
    typesValue = v8::Null(isolate);
    typesHasValueOrDefault = true;
  }
  if (typesHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[1].Get(isolate), typesValue))) {
    return false;
  }

  return true;
}

ReportingObserverOptions NativeValueTraits<ReportingObserverOptions>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  ReportingObserverOptions impl;
  V8ReportingObserverOptions::ToImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
