// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/blink/renderer/bindings/templates/dictionary_v8.cpp.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "third_party/blink/renderer/bindings/modules/v8/v8_payer_error_fields.h"

#include "base/stl_util.h"
#include "third_party/blink/renderer/bindings/core/v8/idl_types.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"

namespace blink {

static const v8::Eternal<v8::Name>* eternalV8PayerErrorFieldsKeys(v8::Isolate* isolate) {
  static const char* const kKeys[] = {
    "email",
    "name",
    "phone",
  };
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(
      kKeys, kKeys, base::size(kKeys));
}

void V8PayerErrorFields::ToImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, PayerErrorFields& impl, ExceptionState& exceptionState) {
  if (IsUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.ThrowTypeError("cannot convert to dictionary.");
    return;
  }
  v8::Local<v8::Object> v8Object = v8Value.As<v8::Object>();
  ALLOW_UNUSED_LOCAL(v8Object);

  const v8::Eternal<v8::Name>* keys = eternalV8PayerErrorFieldsKeys(isolate);
  v8::TryCatch block(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> emailValue;
  if (!v8Object->Get(context, keys[0].Get(isolate)).ToLocal(&emailValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (emailValue.IsEmpty() || emailValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> emailCppValue = emailValue;
    if (!emailCppValue.Prepare(exceptionState))
      return;
    impl.setEmail(emailCppValue);
  }

  v8::Local<v8::Value> nameValue;
  if (!v8Object->Get(context, keys[1].Get(isolate)).ToLocal(&nameValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (nameValue.IsEmpty() || nameValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> nameCppValue = nameValue;
    if (!nameCppValue.Prepare(exceptionState))
      return;
    impl.setName(nameCppValue);
  }

  v8::Local<v8::Value> phoneValue;
  if (!v8Object->Get(context, keys[2].Get(isolate)).ToLocal(&phoneValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (phoneValue.IsEmpty() || phoneValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> phoneCppValue = phoneValue;
    if (!phoneCppValue.Prepare(exceptionState))
      return;
    impl.setPhone(phoneCppValue);
  }
}

v8::Local<v8::Value> PayerErrorFields::ToV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8PayerErrorFields(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8PayerErrorFields(const PayerErrorFields& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  const v8::Eternal<v8::Name>* keys = eternalV8PayerErrorFieldsKeys(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> emailValue;
  bool emailHasValueOrDefault = false;
  if (impl.hasEmail()) {
    emailValue = V8String(isolate, impl.email());
    emailHasValueOrDefault = true;
  }
  if (emailHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[0].Get(isolate), emailValue))) {
    return false;
  }

  v8::Local<v8::Value> nameValue;
  bool nameHasValueOrDefault = false;
  if (impl.hasName()) {
    nameValue = V8String(isolate, impl.name());
    nameHasValueOrDefault = true;
  }
  if (nameHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[1].Get(isolate), nameValue))) {
    return false;
  }

  v8::Local<v8::Value> phoneValue;
  bool phoneHasValueOrDefault = false;
  if (impl.hasPhone()) {
    phoneValue = V8String(isolate, impl.phone());
    phoneHasValueOrDefault = true;
  }
  if (phoneHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[2].Get(isolate), phoneValue))) {
    return false;
  }

  return true;
}

PayerErrorFields NativeValueTraits<PayerErrorFields>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  PayerErrorFields impl;
  V8PayerErrorFields::ToImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
