// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/blink/renderer/bindings/templates/dictionary_v8.cpp.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_rtcp_parameters.h"

#include "base/stl_util.h"
#include "third_party/blink/renderer/bindings/core/v8/idl_types.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"

namespace blink {

static const v8::Eternal<v8::Name>* eternalV8RTCRtcpParametersKeys(v8::Isolate* isolate) {
  static const char* const kKeys[] = {
    "cname",
    "reducedSize",
  };
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(
      kKeys, kKeys, base::size(kKeys));
}

void V8RTCRtcpParameters::ToImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, RTCRtcpParameters& impl, ExceptionState& exceptionState) {
  if (IsUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.ThrowTypeError("cannot convert to dictionary.");
    return;
  }
  v8::Local<v8::Object> v8Object = v8Value.As<v8::Object>();
  ALLOW_UNUSED_LOCAL(v8Object);

  const v8::Eternal<v8::Name>* keys = eternalV8RTCRtcpParametersKeys(isolate);
  v8::TryCatch block(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> cnameValue;
  if (!v8Object->Get(context, keys[0].Get(isolate)).ToLocal(&cnameValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (cnameValue.IsEmpty() || cnameValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> cnameCppValue = cnameValue;
    if (!cnameCppValue.Prepare(exceptionState))
      return;
    impl.setCname(cnameCppValue);
  }

  v8::Local<v8::Value> reducedSizeValue;
  if (!v8Object->Get(context, keys[1].Get(isolate)).ToLocal(&reducedSizeValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (reducedSizeValue.IsEmpty() || reducedSizeValue->IsUndefined()) {
    // Do nothing.
  } else {
    bool reducedSizeCppValue = NativeValueTraits<IDLBoolean>::NativeValue(isolate, reducedSizeValue, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setReducedSize(reducedSizeCppValue);
  }
}

v8::Local<v8::Value> RTCRtcpParameters::ToV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8RTCRtcpParameters(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8RTCRtcpParameters(const RTCRtcpParameters& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  const v8::Eternal<v8::Name>* keys = eternalV8RTCRtcpParametersKeys(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> cnameValue;
  bool cnameHasValueOrDefault = false;
  if (impl.hasCname()) {
    cnameValue = V8String(isolate, impl.cname());
    cnameHasValueOrDefault = true;
  }
  if (cnameHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[0].Get(isolate), cnameValue))) {
    return false;
  }

  v8::Local<v8::Value> reducedSizeValue;
  bool reducedSizeHasValueOrDefault = false;
  if (impl.hasReducedSize()) {
    reducedSizeValue = v8::Boolean::New(isolate, impl.reducedSize());
    reducedSizeHasValueOrDefault = true;
  }
  if (reducedSizeHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[1].Get(isolate), reducedSizeValue))) {
    return false;
  }

  return true;
}

RTCRtcpParameters NativeValueTraits<RTCRtcpParameters>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  RTCRtcpParameters impl;
  V8RTCRtcpParameters::ToImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
