// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/blink/renderer/bindings/templates/dictionary_v8.cpp.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "third_party/blink/renderer/bindings/modules/v8/v8_webgpu_adapter_descriptor.h"

#include "base/stl_util.h"
#include "third_party/blink/renderer/bindings/core/v8/idl_types.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"

namespace blink {

static const v8::Eternal<v8::Name>* eternalV8WebGPUAdapterDescriptorKeys(v8::Isolate* isolate) {
  static const char* const kKeys[] = {
    "powerPreference",
  };
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(
      kKeys, kKeys, base::size(kKeys));
}

void V8WebGPUAdapterDescriptor::ToImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, WebGPUAdapterDescriptor& impl, ExceptionState& exceptionState) {
  if (IsUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.ThrowTypeError("cannot convert to dictionary.");
    return;
  }
  v8::Local<v8::Object> v8Object = v8Value.As<v8::Object>();
  ALLOW_UNUSED_LOCAL(v8Object);

  const v8::Eternal<v8::Name>* keys = eternalV8WebGPUAdapterDescriptorKeys(isolate);
  v8::TryCatch block(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> powerPreferenceValue;
  if (!v8Object->Get(context, keys[0].Get(isolate)).ToLocal(&powerPreferenceValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (powerPreferenceValue.IsEmpty() || powerPreferenceValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> powerPreferenceCppValue = powerPreferenceValue;
    if (!powerPreferenceCppValue.Prepare(exceptionState))
      return;
    const char* validValues[] = {
        "default",
        "low-power",
        "high-performance",
    };
    if (!IsValidEnum(powerPreferenceCppValue, validValues, base::size(validValues), "WebGPUPowerPreference", exceptionState))
      return;
    impl.setPowerPreference(powerPreferenceCppValue);
  }
}

v8::Local<v8::Value> WebGPUAdapterDescriptor::ToV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8WebGPUAdapterDescriptor(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8WebGPUAdapterDescriptor(const WebGPUAdapterDescriptor& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  const v8::Eternal<v8::Name>* keys = eternalV8WebGPUAdapterDescriptorKeys(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> powerPreferenceValue;
  bool powerPreferenceHasValueOrDefault = false;
  if (impl.hasPowerPreference()) {
    powerPreferenceValue = V8String(isolate, impl.powerPreference());
    powerPreferenceHasValueOrDefault = true;
  } else {
    powerPreferenceValue = V8String(isolate, "default");
    powerPreferenceHasValueOrDefault = true;
  }
  if (powerPreferenceHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[0].Get(isolate), powerPreferenceValue))) {
    return false;
  }

  return true;
}

WebGPUAdapterDescriptor NativeValueTraits<WebGPUAdapterDescriptor>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  WebGPUAdapterDescriptor impl;
  V8WebGPUAdapterDescriptor::ToImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
