// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   core/css/properties/templates/css_property_subclass.h.tmpl
// and input files:
//   ../../3rdparty/chromium/third_party/blink/renderer/core/css/ComputedStyleFieldAliases.json5
//   ../../3rdparty/chromium/third_party/blink/renderer/core/css/CSSProperties.json5
//   ../../3rdparty/chromium/third_party/blink/renderer/core/css/properties/CSSPropertyMethods.json5


#ifndef THIRD_PARTY_BLINK_RENDERER_CORE_CSS_PROPERTIES_LONGHAND_TEXT_DECORATION_STYLE_H_
#define THIRD_PARTY_BLINK_RENDERER_CORE_CSS_PROPERTIES_LONGHAND_TEXT_DECORATION_STYLE_H_

#include "third_party/blink/renderer/core/css/css_identifier_value.h"
#include "third_party/blink/renderer/core/css/css_primitive_value_mappings.h"
#include "third_party/blink/renderer/core/css/properties/longhand.h"
#include "third_party/blink/renderer/core/css/resolver/style_resolver_state.h"
#include "third_party/blink/renderer/core/style/computed_style.h"

namespace blink {
namespace CSSLonghand {

// Implements the 'text-decoration-style' CSS property
// See src/third_party/WebKit/Source/core/css/properties/README.md
class TextDecorationStyle final : public Longhand {
 public:
  constexpr TextDecorationStyle() : Longhand() {}
  const char* GetPropertyName() const override { return "text-decoration-style\0"; }
  const WTF::AtomicString& GetPropertyNameAtomicString() const override {
    static const WTF::AtomicString& name = WTF::AtomicString("text-decoration-style\0");
    return name;
  }
  const WTF::String GetJSPropertyName() const override {
    return WTF::String("textDecorationStyle\0");
  }
  CSSPropertyID PropertyID() const override { return CSSPropertyTextDecorationStyle; }
  const CSSValue* CSSValueFromComputedStyleInternal(const ComputedStyle&, const SVGComputedStyle&, const LayoutObject*, Node*, bool allow_visited_style) const override;

  // Style builder functions
  void ApplyInitial(StyleResolverState& state) const override {
    state.Style()->SetTextDecorationStyle(ComputedStyleInitialValues::InitialTextDecorationStyle());
  }
  void ApplyInherit(StyleResolverState& state) const override {
    state.Style()->SetTextDecorationStyle(state.ParentStyle()->TextDecorationStyle());
  }
  void ApplyValue(StyleResolverState& state, const CSSValue& value) const override {
    state.Style()->SetTextDecorationStyle(ToCSSIdentifierValue(value).ConvertTo<blink::ETextDecorationStyle>());
  }
};

}  // namespace CSSLonghand
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_CORE_CSS_PROPERTIES_LONGHAND_TEXT_DECORATION_STYLE_H_
