// Copyright (c) 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   templates/web_origin_trials.cc.tmpl
// and input files:
//   ../../3rdparty/chromium/third_party/blink/renderer/platform/runtime_enabled_features.json5


#include "third_party/blink/public/web/web_origin_trials.h"

#include "third_party/blink/renderer/core/dom/document.h"
#include "third_party/blink/renderer/core/origin_trials/origin_trials.h"
#include "third_party/blink/public/platform/web_string.h"
#include "third_party/blink/public/web/web_document.h"

namespace blink {

bool WebOriginTrials::isTrialEnabled(const WebDocument* web_document, const WebString& trial) {
  if (!web_document) return false;
  if (trial == OriginTrials::kAnimationWorkletTrialName)
    return OriginTrials::AnimationWorkletEnabled(*web_document);
  if (trial == OriginTrials::kBudgetQueryTrialName)
    return OriginTrials::BudgetQueryEnabled(*web_document);
  if (trial == OriginTrials::kCookieStoreTrialName)
    return OriginTrials::CookieStoreEnabled(*web_document);
  if (trial == OriginTrials::kDisableHardwareNoiseSuppressionTrialName)
    return OriginTrials::DisableHardwareNoiseSuppressionEnabled(*web_document);
  if (trial == OriginTrials::kEncryptedMediaHdcpPolicyCheckTrialName)
    return OriginTrials::EncryptedMediaHdcpPolicyCheckEnabled(*web_document);
  if (trial == OriginTrials::kEventTimingTrialName)
    return OriginTrials::EventTimingEnabled(*web_document);
  if (trial == OriginTrials::kExperimentalHardwareEchoCancellationTrialName)
    return OriginTrials::ExperimentalHardwareEchoCancellationEnabled(*web_document);
  if (trial == OriginTrials::kFeaturePolicyJavaScriptInterfaceTrialName)
    return OriginTrials::FeaturePolicyJavaScriptInterfaceEnabled(*web_document);
  if (trial == OriginTrials::kInstalledAppTrialName)
    return OriginTrials::InstalledAppEnabled(*web_document);
  if (trial == OriginTrials::kLowLatencyCanvasTrialName)
    return OriginTrials::LowLatencyCanvasEnabled(*web_document);
  if (trial == OriginTrials::kMediaCapabilitiesTrialName)
    return OriginTrials::MediaCapabilitiesEnabled(*web_document);
  if (trial == OriginTrials::kOriginTrialsSampleAPITrialName)
    return OriginTrials::OriginTrialsSampleAPIEnabled(*web_document);
  if (trial == OriginTrials::kOriginTrialsSampleAPIImpliedTrialName)
    return OriginTrials::OriginTrialsSampleAPIImpliedEnabled(*web_document);
  if (trial == OriginTrials::kRtcPeerConnectionIdTrialName)
    return OriginTrials::RtcPeerConnectionIdEnabled(*web_document);
  if (trial == OriginTrials::kSignatureBasedIntegrityTrialName)
    return OriginTrials::SignatureBasedIntegrityEnabled(*web_document);
  if (trial == OriginTrials::kStaleWhileRevalidateTrialName)
    return OriginTrials::StaleWhileRevalidateEnabled(*web_document);
  if (trial == OriginTrials::kTouchEventFeatureDetectionTrialName)
    return OriginTrials::TouchEventFeatureDetectionEnabled(*web_document);
  if (trial == OriginTrials::kWebXRTrialName)
    return OriginTrials::WebXREnabled(*web_document);
  if (trial == OriginTrials::kWebXRGamepadSupportTrialName)
    return OriginTrials::WebXRGamepadSupportEnabled(*web_document);
  return false;
}


} // namespace blink
